
#include "ceres.h"
#include "fftsound.h"



void newFFTSound(struct FFTSound *fftsound){
  
}



struct FFTSound *makeFFTSoundCopy(struct FFTSound *fftsound,int start,int end){
  struct FFTSound *ret=malloc(sizeof(struct FFTSound));

  memcpy(ret,fftsound,sizeof(struct FFTSound));

  ret->horiz_num=end-start;


  ret->megfreq.dac.s[0].mem=malloc(sizeof(float)*(ret->horiz_num*fftsound->total_channels));
  ret->megfreq.dac.s[0].start=0;
  ret->megfreq.dac.s[0].end=ret->horiz_num*fftsound->total_channels;

  ret->megamp.dac.s[0].mem=malloc(sizeof(float)*(ret->horiz_num*fftsound->total_channels));
  ret->megamp.dac.s[0].start=0;
  ret->megamp.dac.s[0].end=ret->horiz_num*fftsound->total_channels;

  ret->megamp.dac.file=NULL;

  ret->usemem=true;

  ret->dontfreeme=false;

  return ret;
}

void copyFFTSound(struct FFTSound *from,struct FFTSound *to,int fromstart){

  size_t len=min(from->horiz_num-fromstart,to->horiz_num);

#if 1

  DA_copy(
	  &from->megfreq,
	  &to->megfreq,
	  fromstart*to->total_channels,
	  0,
	  len*to->total_channels
	  );

  DA_copy(
	  &from->megamp,
	  &to->megamp,
	  fromstart*to->total_channels,
	  0,
	  len*to->total_channels
	  );


#else
  memcpy(to->megfreq,from->megfreq+(fromstart*fftsound->total_channels),sizeof(float)*len*fftsound->total_channels);
  memcpy(to->megamp,from->megamp+(fromstart*fftsound->total_channels),sizeof(float)*len*fftsound->total_channels);
#endif
}

void freeFFTSound(struct FFTSound *fftsound){

  free(fftsound->megamp.dac.s[0].mem);
  free(fftsound->megfreq.dac.s[0].mem);

  free(fftsound);
}

